=== Bundles/LeafCtrl/ctrlMemory/CMakeLists.txt ===
fwLoadProperties()
fwUseForwardInclude(
    fwData
    fwRuntime
    fwServices

    ctrlSelection
)
