=== debian/changelog ===
fw4spl (0.9.2-3) unstable; urgency=medium

  * Restrict package to amd64. Closes: #790288.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Thu, 16 Jul 2015 11:16:32 +0200

fw4spl (0.9.2-2) unstable; urgency=medium

  * Replace files from libqt4-qt3support by symlinks. Closes: #781298.
  * Fix FindHdf5.cmake to find hdf5 on i386 arch. Closes: #781294.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Fri, 27 Mar 2015 17:03:34 +0100

fw4spl (0.9.2-1) unstable; urgency=low

  * Initial release (Closes: #779632)

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Mon, 23 Mar 2015 11:19:00 +0100
