=== debian/control ===
Source: fw4spl
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Corentin Desfarges <corentin.desfarges.dev@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake (>= 2.8.11),
               libboost-all-dev (>= 1.54),
               zlib1g-dev,
               libexpat1-dev,
               libpng-dev,
               libtiff5-dev,
               libcppunit-dev,
               libhdf5-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libqt4-qt3support,
               libvtk5-dev,
               libgdcm2-dev,
               libinsighttoolkit3-dev,
               libann-dev,
               libvtkgdcm2-dev,
               libvtk5.8-qt4,
               libvxl1-dev,
               libcamp0.7-dev,
               xvfb,
               xauth,
               dbus-x11,
               rdfind,
               symlinks
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/fw4spl.git
Vcs-Git: git://anonscm.debian.org/debian-med/fw4spl.git
Homepage: https://code.google.com/p/fw4spl/

Package: fw4spl
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: FrameWork for Software Production Line
 FW4SPL consists of a set of cross-platform C++ libraries.
 For now, FW4SPL focuses on the problem of medical images 
 processing and visualization, and propose an open-source 
 application called VRRender, which is able to load a 
 series of images stored in DICOM format (uncompressed 
 and JPEG) and 3D-modeled patients for medical review.
