=== Utilities/DicomAnonymizer/CMakeLists.txt ===
fwLoadProperties()

find_package(Boost COMPONENTS program_options REQUIRED)
fwLink(${Boost_LIBRARIES})
