=== Utilities/VersionGenerator/CMakeLists.txt ===
fwLoadProperties()

find_package (Boost COMPONENTS program_options REQUIRED)

fwLink(
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
)
