=== debian/changelog ===
fw4spl (14.0.0-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:50:06 +0000

fw4spl (14.0.0-1) unstable; urgency=medium

  [ Flavien Bridault ]
  * New upstream version 
  * d/p/: remove obsolete patches
    Add patch to enable experimental GLM extension. Closes: #888932
  * d/rules: update build options

  [ Andreas Tille ]
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 28 Feb 2018 13:24:10 +0000

fw4spl (11.0.4-2) unstable; urgency=medium

  * Team upload.
  * d/control: Move to standards version 4.0.1
  * d/p/: Add patch fix_functional_include, Closes: #871111

 -- Gert Wollny <gewo@debian.org>  Mon, 21 Aug 2017 12:26:44 +0000

fw4spl (11.0.4-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload
  * Fix Homepage
    Closes: #812904

  [ Flavien Bridault ]
  * New upstream version
    Support libpng16. Closes: #809935.
    Support vtk6. Closes: #820632.
    Support insighttoolkit4. Closes: #821957.
    Support gcc5 build. Closes: #793240.
  * Removed Corentin Desfarges as Uploader
  * Added myself as Uploader
  * d/watch: Moved to official fw4spl fork
  * debhelper 10 (which enables parallel build as default). Closes: #797475.
  * d/control: Updated dependencies
  * cme fix dpkg-control 

 -- Flavien Bridault <fbridault@ircad.fr>  Wed, 23 Nov 2016 09:58:17 +0100

fw4spl (0.9.2-4) unstable; urgency=medium

  * Fix arm support.
  * Remove restriction to amd64.
  * Update dependencies in d/control.
  * Support new boost version. Closes: #797481.
  * Forbid parallel build. Closes: #797475.

 -- Corentin Desfarges <corentin.desfarges.dev@gmail.com>  Thu, 21 Dec 2015 14:11:13 +0200
